OGRE-Next: Ogre::v1::MetalHardwareVertexBuffer Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | List of all members
Ogre::v1::MetalHardwareVertexBuffer Class Referencefinal

Specialisation of HardwareVertexBuffer for Metal. More...

`#include <OgreMetalHardwareVertexBuffer.h>`

Inheritance diagram for Ogre::v1::MetalHardwareVertexBuffer:
[legend]

## Public Member Functions
| MetalHardwareVertexBuffer (MetalHardwareBufferManagerBase *mgr, size_t vertexSize, size_t numVertices, HardwareBuffer::Usage usage, bool useShadowBuffer)
| ~MetalHardwareVertexBuffer () override
void | _notifyDeviceStalled ()
void | _updateFromShadow () override
| Updates the real buffer from the shadow buffer, if required.
void | copyData (HardwareBuffer &srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false) override
| Copy data from another buffer into this one.
id< MTLBuffer > | getBufferName (size_t &outOffset)
| Returns the actual API buffer, but first sets mLastFrameUsed as we assume you're calling this function to use the buffer in the GPU.
id< MTLBuffer > | getBufferNameForGpuWrite ()
void * | getRenderSystemData () override
| An internal function that should be used only by a render system for internal use.
void | readData (size_t offset, size_t length, void *pDest) override
| Reads data from the buffer and places it in the memory pointed to by pDest.
void | writeData (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false) override
| Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.
Public Member Functions inherited from Ogre::v1::HardwareVertexBuffer
| HardwareVertexBuffer (HardwareBufferManagerBase *mgr, size_t vertexSize, size_t numVertices, HardwareBuffer::Usage usage, bool useSystemMemory, bool useShadowBuffer)
| Should be called by HardwareBufferManager.
| ~HardwareVertexBuffer ()
size_t | getInstanceDataStepRate () const
| Get the number of instances to draw using the same per-instance data before advancing in the buffer by one element.
bool | getIsInstanceData () const
| Get if this vertex buffer is an "instance data" buffer (per instance)
HardwareBufferManagerBase * | getManager () const
| Return the manager of this buffer, if any.
size_t | getNumVertices () const
| Get the number of vertices in this buffer.
size_t | getVertexSize () const
| Gets the size in bytes of a single vertex in this buffer.
void | setInstanceDataStepRate (const size_t val)
| Set the number of instances to draw using the same per-instance data before advancing in the buffer by one element.
void | setIsInstanceData (const bool val)
| Set if this vertex buffer is an "instance data" buffer (per instance)
Public Member Functions inherited from Ogre::v1::HardwareBuffer
| HardwareBuffer (Usage usage, bool systemMemory, bool useShadowBuffer)
| Constructor, to be called by HardwareBufferManager only.
virtual | ~HardwareBuffer ()
virtual void | copyData (HardwareBuffer &srcBuffer)
| Copy all data from another buffer into this one.
size_t | getSizeInBytes () const
| Returns the size of this buffer in bytes.
Usage | getUsage () const
| Returns the Usage flags with which this buffer was created.
bool | hasShadowBuffer () const
| Returns whether this buffer has a system memory shadow for quicker reading.
bool | isLocked () const
| Returns whether or not this buffer is currently locked.
bool | isSystemMemory () const
| Returns whether this buffer is held in system memory.
void * | lock (LockOptions options)
| Lock the entire buffer for (potentially) reading / writing.
virtual void * | lock (size_t offset, size_t length, LockOptions options)
| Lock the buffer for (potentially) reading / writing.
void | suppressHardwareUpdate (bool suppress)
| Pass true to suppress hardware upload of shadow buffer changes.
virtual void | unlock ()
| Releases the lock on this buffer.

## Additional Inherited Members
Public Types inherited from Ogre::v1::HardwareBuffer
enum | LockOptions { HBL_NORMAL , HBL_DISCARD , HBL_READ_ONLY , HBL_NO_OVERWRITE , HBL_WRITE_ONLY }
| Locking options. More...
enum | Usage { HBU_STATIC = 1 , HBU_DYNAMIC = 2 , HBU_WRITE_ONLY = 4 , HBU_DISCARDABLE = 8 , HBU_STATIC_WRITE_ONLY = 5 , HBU_DYNAMIC_WRITE_ONLY = 6 , HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = 14 }
| Enums describing buffer usage; not mutually exclusive. More...

## Detailed Description

Specialisation of HardwareVertexBuffer for Metal.

## Constructor & Destructor Documentation

## ◆ MetalHardwareVertexBuffer()

Ogre::v1::MetalHardwareVertexBuffer::MetalHardwareVertexBuffer | ( | MetalHardwareBufferManagerBase * | mgr,
|  | size_t | vertexSize,
|  | size_t | numVertices,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer )

## ◆ ~MetalHardwareVertexBuffer()

Ogre::v1::MetalHardwareVertexBuffer::~MetalHardwareVertexBuffer | ( |  | ) |
| override

## Member Function Documentation

## ◆ _notifyDeviceStalled()

void Ogre::v1::MetalHardwareVertexBuffer::_notifyDeviceStalled | ( |  | ) |

## ◆ _updateFromShadow()

void Ogre::v1::MetalHardwareVertexBuffer::_updateFromShadow | ( |  | ) |
| overridevirtual

Updates the real buffer from the shadow buffer, if required.

Reimplemented from Ogre::v1::HardwareBuffer.

## ◆ copyData()

void Ogre::v1::MetalHardwareVertexBuffer::copyData | ( | HardwareBuffer & | srcBuffer,
|  | size_t | srcOffset,
|  | size_t | dstOffset,
|  | size_t | length,
|  | bool | discardWholeBuffer = false )
| overridevirtual

Copy data from another buffer into this one.

Remarks
  Note that the source buffer must not be created with the usage HBU_WRITE_ONLY otherwise this will fail.

Parameters

  srcBuffer | The buffer from which to read the copied data
  srcOffset | Offset in the source buffer at which to start reading
  dstOffset | Offset in the destination buffer to start writing
  length | Length of the data to copy, in bytes.
  discardWholeBuffer | If true, will discard the entire contents of this buffer before copying

Reimplemented from Ogre::v1::HardwareBuffer.

## ◆ getBufferName()

id< MTLBuffer > Ogre::v1::MetalHardwareVertexBuffer::getBufferName | ( | size_t & | outOffset | ) |

Returns the actual API buffer, but first sets mLastFrameUsed as we assume you're calling this function to use the buffer in the GPU.

Parameters

  outOffset | Out. Guaranteed to be written. Used by HBU_DISCARDABLE buffers which need an offset to the internal ring buffer we've allocated.

Returns
  The MTLBuffer in question.

## ◆ getBufferNameForGpuWrite()

id< MTLBuffer > Ogre::v1::MetalHardwareVertexBuffer::getBufferNameForGpuWrite | ( |  | ) |

## ◆ getRenderSystemData()

void * Ogre::v1::MetalHardwareVertexBuffer::getRenderSystemData | ( |  | ) |
| overridevirtual

An internal function that should be used only by a render system for internal use.

Reimplemented from Ogre::v1::HardwareBuffer.

## ◆ readData()

void Ogre::v1::MetalHardwareVertexBuffer::readData | ( | size_t | offset,
|  | size_t | length,
|  | void * | pDest )
| overridevirtual

Reads data from the buffer and places it in the memory pointed to by pDest.

Parameters

  offset | The byte offset from the start of the buffer to read
  length | The size of the area to read, in bytes
  pDest | The area of memory in which to place the data, must be large enough to accommodate the data!

Implements Ogre::v1::HardwareBuffer.

## ◆ writeData()

void Ogre::v1::MetalHardwareVertexBuffer::writeData | ( | size_t | offset,
|  | size_t | length,
|  | const void * | pSource,
|  | bool | discardWholeBuffer = false )
| overridevirtual

Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.

Parameters

  offset | The byte offset from the start of the buffer to start writing
  length | The size of the data to write to, in bytes
  pSource | The source of the data to be written
  discardWholeBuffer | If true, this allows the driver to discard the entire buffer when writing, such that DMA stalls can be avoided; use if you can.

Implements Ogre::v1::HardwareBuffer.

The documentation for this class was generated from the following file:

- OgreMetalHardwareVertexBuffer.h